<?php defined("UBB_MAIN_PROGRAM") or exit;
//	Script Version 7.6.0

// Setup the smarty class
require('../libs/smarty/Smarty.class.php');
$smarty = new Smarty();

$smarty->template_dir = 'templates/default';
$smarty->compile_dir = 'templates/compile';

// include all of the required libraries
require_once("../libs/phpmailer/class.phpmailer.php");
require_once("../includes/config.inc.php");
require_once("../libs/mysql.inc.php");
require_once("../libs/bbcode.inc.php");
require_once("../styles/wrappers.php");
require_once("../libs/html.inc.php");
require_once("../libs/mailer.inc.php");
require_once("../libs/user.inc.php");
require_once("../libs/ubbthreads.inc.php");

/**
 * Should each new item increase the user's post count?
 */
$config['TOPIC_FEED_INC_POSTCOUNT'] = false;

$html =& new html;

$name = array();

$blocked_tags_content = array( 'script', 'style', 'body', 'html', 'embed', 'object', 'applet', 'form', 'xmp' );
$blocked_tags_no_content = array( 'link', 'input', '\?', 'param' );

define( 'TIMENOW', time() );

/**
 * Account for change in semantics in PHP 5.1
 * http://us2.php.net/strtotime#AEN29881
 */
if( version_compare( PHP_VERSION, "5.1.0", ">=") ) {
	define( 'INVALID_STRTOTIME', false );
} else {
	define( 'INVALID_STRTOTIME', -1 );
}

$query = "
	SELECT * FROM {$config['TABLE_PREFIX']}TOPIC_FEEDS
	WHERE LAST_BUILD < ( ? - ( CACHE_TIME * 60 ) ) AND FEED_IS_ENABLED = '1'
	ORDER BY LAST_BUILD ASC
	LIMIT 1
";

$sth = $dbh->do_placeholder_query($query, array(TIMENOW), __LINE__, __FILE__);
$xml = "";
$result = "";

if (($result = $dbh->fetch_array($sth)) && $xml = getFeed($result['FEED_URL']) ) {
	$most_recent_time = $result['LAST_TOPIC_TIME'];
	
	// Grab the display name of the 'person' who will be posting this
	$query = "SELECT USER_DISPLAY_NAME FROM {$config['TABLE_PREFIX']}USERS WHERE USER_ID = ?";
	$sth2 = $dbh->do_placeholder_query( $query, array( $result['USER_ID'] ), __LINE__, __FILE__ );
	
	list($display_name) = $dbh->fetch_array( $sth2 );
	$name = array($display_name, 0, $result['USER_ID']);	

	foreach( $xml as $feed ) {
		if( isset( $feed['dc:date'] ) ) {
			$feed['pubdate'] = $feed['dc:date'];
		}
		
		$feed['pubdate'] = @strtotime( $feed['pubdate'] );

		if( $feed['pubdate'] === INVALID_STRTOTIME ) {
			// We don't get a valid time, nothing we can do for this.
			break;
		}

		if( $feed['pubdate'] <= $result['LAST_TOPIC_TIME'] ) {
			break;
		}

		$most_recent_time = $feed['pubdate'] > $most_recent_time ? $feed['pubdate'] : $most_recent_time;		

		if( ! $feed['title'] ) {
			break;
		}


			// Correct unicode charactors in title
			$feed['title'] = str_replace( '’', '\'', $feed['title'] );
			$feed['title'] = str_replace( '“', '\"', $feed['title'] );
			$feed['title'] = str_replace( '', '\'', $feed['title'] );
			$feed['title'] = str_replace( '', '\"', $feed['title'] );
			$feed['title'] = str_replace( '”', '\"', $feed['title'] );
			$feed['title'] = str_replace( '£', '', $feed['title'] );
			$feed['title'] = str_replace( '¥', '', $feed['title'] );
			$feed['title'] = str_replace( '', '', $feed['title'] );



		$feed['title_appended'] = $feed['title'];
		if( $result['TITLE_PREFIX'] ) {
			$feed['title_appended'] = $feed['title_appended'] . " " . $result['TITLE_PREFIX'];
		}
		
		$name[1]++;		
		
		$icon = "";
		if (isset($result['TOPIC_ICON']) && $result['TOPIC_ICON'] != "") {
			$icon = $result['TOPIC_ICON'];
		} else {
			$icon = "blank.gif";
		}

		// Create topic
		$query = "
			INSERT INTO {$config['TABLE_PREFIX']}TOPICS
			( FORUM_ID, POST_ID, USER_ID, TOPIC_SUBJECT, TOPIC_CREATED_TIME, TOPIC_IS_APPROVED, TOPIC_LAST_POSTER_ID, TOPIC_LAST_POSTER_NAME, TOPIC_LAST_REPLY_TIME, TOPIC_ICON )
			VALUES ( ?, ?, ?, ?, ?, '1', ?, ?, ?, ? )
		";


		$insert_time = $feed['pubdate'];

		$dbh->do_placeholder_query( $query, array( $result['FORUM_ID'], 0, $result['USER_ID'], $feed['title_appended'], $insert_time, $result['USER_ID'], $display_name, $insert_time, $icon ), __LINE__, __FILE__ );

		// Get the topic id
		$query = "SELECT last_insert_id()";
		$sth2 = $dbh->do_query( $query, __LINE__, __FILE__ );
		list( $tid ) = $dbh->fetch_array( $sth2 );

		$body = $result['BODY_FORMAT'];

		foreach( $feed as $k => $v ) {
			$k = strtoupper( $k );
			$body = str_replace( "%%{$k}%%", trim( $v ), $body );
		}


		$body_parsed = "";
		$type = "html";
		
		if( $result['FEED_WAS_ESCAPED'] ) {
			$body = str_replace( '&lt;', '<', $body );
			$body = str_replace( '&gt;', '>', $body );
			$body = str_replace( '&amp;', '&', $body );
		}


			// Correct unicode charactors in body
			$body = str_replace( '’', '\'', $body );
			$body = str_replace( '“', '"', $body );
			$body = str_replace( '', '\'', $body );
			$body = str_replace( '', '"', $body );
			$body = str_replace( '”', '"', $body );

			$body = str_replace( '€', 'E', $body );


			$body = str_replace( '£', '', $body );
			$body = str_replace( '¥', '', $body );
			$body = str_replace( '', '', $body );
			$body = str_replace( '', '-', $body );


			// Remove extra line feeds in body
			$body = str_replace( '<p>', '<br>', $body );
			$body = str_replace( '<p class="spip">', '<br>', $body );


			$body = str_replace( '</p>', '', $body );

			$body = str_replace( 'width="100%"', '', $body );



		if (isset($result['REGEXP_SPECIAL']) && $feed['REGEXP_SPECIAL'] ) {
			// Example line:
			// <a href="amazon.com/(.+?)">|^|<a href="amazon.com/foo/\1">
			
			$lines = explode( "\n", $result['REGEXP_SPECIAL'] );
			foreach ($lines as $line) {
				list ($find, $replace) = explode($line, "|^|");				
				$pattern = "#" . str_replace('#', '\#', $find) . "#i";				
				$body = @preg_replace($pattern, rtrim($replace), $body);
//				$body = @eregi_replace($pattern, rtrim($replace), $body);
			}
		}
		
		foreach ($blocked_tags_content as $tag) {
			$body = @preg_replace( "#<{$tag}[^>]*>([^<])*</{$tag}>#i", '\1', $body );
		}
		
		foreach ($blocked_tags_no_content as $tag) {
			$body = @preg_replace( "#<{$tag}[^>]*>#i", '', $body );
		}
		
		if( $result['PARSE_BBCODE'] ) {
			$body_parsed = $html->do_markup( $body, "post", "both" );
			$type = "both";
		} else {
			$body_parsed = $body;
		}

		// Create post
		$query = "
			INSERT INTO {$config['TABLE_PREFIX']}POSTS
			( TOPIC_ID, USER_ID, POST_IS_TOPIC, POST_IS_MEMBER_POST, POST_POSTED_TIME,
			  POST_ADD_SIGNATURE, POST_DEFAULT_BODY, POST_BODY, POST_SUBJECT, POST_MARKUP_TYPE )
			VALUES
			( ?, ?, '1', '1', ?,
			  '1', ?, ?, ?, ? )
		";

		$dbh->do_placeholder_query( $query, array( $tid, $result['USER_ID'], $insert_time, $body, $body_parsed, $feed['title_appended'], $type ), __LINE__, __FILE__ );

		// Get the post id
		$query = "SELECT last_insert_id()";
		$sth2 = $dbh->do_query( $query, __LINE__, __FILE__ );
		list( $pid ) = $dbh->fetch_array( $sth2 );

		// Update topic
		$query = "
			UPDATE {$config['TABLE_PREFIX']}TOPICS
			SET TOPIC_LAST_POST_ID = ?, POST_ID = ?
			WHERE TOPIC_ID = ?
		";

		$dbh->do_placeholder_query( $query, array( $pid, $pid, $tid ), __LINE__, __FILE__ );
	}

	$query = "
		UPDATE {$config['TABLE_PREFIX']}TOPIC_FEEDS
		SET LAST_BUILD = ?, LAST_TOPIC_TIME = ?
		WHERE FEED_ID = ?
	";

	$dbh->do_placeholder_query( $query, array( TIMENOW, $most_recent_time, $result['FEED_ID'] ), __LINE__, __FILE__ );
	
	rebuild_forum_data( $result['FORUM_ID'] );
	
	if ($config['TOPIC_FEED_INC_POSTCOUNT']) {
		// Increase the post count of the user "posting" the feed
		$query = "
			UPDATE {$config['TABLE_PREFIX']}USER_PROFILE
			SET USER_TOTAL_POSTS = USER_TOTAL_POSTS + ?
			WHERE USER_ID = ?
		";
		
		$dbh->do_placeholder_query( $query, array($name[1], $result['USER_ID']), __LINE__, __FILE__ );
	}
} else if (is_array($result) && !(is_array($xml) && count($xml) > 0)) {
	$query = "
		UPDATE {$config['TABLE_PREFIX']}TOPIC_FEEDS
		SET LAST_BUILD = ?
		WHERE FEED_ID = ?
	";

	$dbh->do_placeholder_query($query, array(TIMENOW, $result['FEED_ID']), __LINE__, __FILE__);
}

header('Content-type: image/gif');
$im = imagecreatefromgif( $config['FULL_PATH'] . '/images/ubb_donotdelete_blank.gif');
imagegif($im);
exit;
?>
